package tunneler;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 * @author vondrm4
 *
 *
 * obsahuje hlavni okno, jednotlive hrace, pocet kol, mapu
 * nastaveni je predena v konstruktoru ze zavadece,
 * opakovane vykreslovani zajistuje vlakno
 */
public class Hra extends JFrame{

	Hrac[] hraci;
    JLabel info;
    JButton moreBlood;
    JButton konec;
    Panel oknoKonec;
    Panel buttonPanel;
    
    Mapa mapa;
    TestVlakno vlakno;
    
    PohledMapa zobrazMapa;
    int pocetKol;
    int rozliseni;
    int sirka;
    int vyska;
    int load;
    int exitKey[];
	int aktivni;
    Zavadec start;
    
    public Hra(String[] hraciNames, Color[] barvy, int[][][] ovladani, int pocetKol, Zavadec zavadec) {
		super("JTunneler");
		//puvodni okno
		start=zavadec;
	
		rozliseni=5;
		sirka=60;
		vyska=60;
		this.pocetKol=pocetKol;
	
		//delka load screenu a jeho indikace
		load=25;

		//escape
		exitKey=new int[2];
		exitKey[0]=27;
		exitKey[1]=1;
		
		
		mapa=new Mapa(400,300);
	
		//prvky pro ukoncovaci okno
		info=new JLabel("");
		info.setVisible(true);
		moreBlood=new JButton("nova hra");
		moreBlood.addActionListener( new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				start.setVisible(true);
				ukoncit();
			}
		} );
		konec=new JButton("ukoncit");
		konec.addActionListener( new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				System.exit(0); }
		} );
	
		buttonPanel=new Panel();
		buttonPanel.setLayout(new GridLayout(1,2));
		buttonPanel.add(moreBlood);
		buttonPanel.add(konec);
		oknoKonec=new Panel();
		oknoKonec.setLayout(new BorderLayout());
		oknoKonec.add(info, BorderLayout.NORTH);		

		//zobrazovac cele mapy
		zobrazMapa=new PohledMapa(mapa,1);
		oknoKonec.add(zobrazMapa, BorderLayout.CENTER);
		oknoKonec.add(buttonPanel, BorderLayout.SOUTH);
		

		//vytvoreni hracu
		hraci= new Hrac[hraciNames.length];
		for (int i = 0; i < hraci.length; i++) {
			hraci[i]=new Hrac(hraciNames[i], barvy[i], ovladani[i], this);

		}

		//vygeneruje mapu a vrati polohy zakladen
		int[][] base=mapa.generovat(barvy);
		for (int i = 0; i < base.length; i++) {
			hraci[i].setBase(base[i][0], base[i][1]);
		}

		setLayout(new FlowLayout());

		for (int i = 0; i < hraci.length; i++) {
			add(hraci[i]);
		}

		//nastaveni poctu aktivnich hracu pro ukonceni kola
		aktivni=hraci.length;

		setLocation(100, 50);
		addWindowListener(new WinControls());
		setBackground(Color.BLACK);

		int modifikator=1;
		if(hraci.length>2){
			modifikator=2;
		}

		setSize(2*sirka*rozliseni+10*rozliseni,modifikator*(vyska+8)*rozliseni+19*rozliseni);
		setVisible(true);
		addKeyListener(new Klavesnice(this));
	
		//schovani puvod okna
		start.setVisible(false);	
		vlakno=new TestVlakno(this);
		vlakno.start();
    }
    
    public void refresh(){
	//volana vlaknem, dale vola metody hracu pro spocitani kolizi, strel a prekresleni
		if(aktivni <=1){
			for (int i = 0; i < hraci.length; i++) {
				if(hraci[i].aktivni == true) hraci[i].pocetViteztvi ++;
			}
			noveKolo();
			return;
		}
		if(load>1){
			mapa.load=new Color(9*load,9*load,9*load);
			for (int i = 0; i < hraci.length; i++) {
				hraci[i].prekreslitLoad();
			}
			load--;
		}else{
			//nejdrive spocitani vsech strel, pak pohybu tanku
			for (int i = 0; i < hraci.length; i++) {
				hraci[i].strelba();
			}
			for (int i = 0; i < hraci.length; i++) {
				hraci[i].prekreslit();
			}
		}
    }
    private void noveKolo(){
	//volano v refresh kdyz zbyde uz jen jeden hrac
		if(!konecHry()){
			System.out.println("round "+zbytekHracu());
			for (int i = 0; i < hraci.length; i++) {
				hraci[i].noveKolo();
			}
			load=25;
			aktivni=hraci.length;
		}else{
			vlakno.onOff=false;
		}
    }
	private boolean konecHry(){
	//urcuje jestli uz probehlo dostatek kol podle poctu vytezstvi
		int celkemViteztvi=0;
		for (int i = 0; i < hraci.length; i++) {
			celkemViteztvi +=hraci[i].pocetViteztvi;
		}
		if(celkemViteztvi < pocetKol) return false;
		return true;
	}

    public void end(){
	//vola se z testVlakna, po nastaveni onOff false z noveho kola nebo zmacknutim escape
		for (int i = 0; i < hraci.length; i++) {
			remove(hraci[i]);
		}
		info.setText(vitez());
		info.setVisible(true);
		info.setSize(100,100);
	
		zobrazMapa.repaint();
		this.add(oknoKonec);
		this.setVisible(false);
		this.setVisible(true);

    }
    private String vitez(){
		int max=0;
		boolean remiza=false;
		for (int i = 1; i < hraci.length; i++) {
			if(hraci[i].pocetViteztvi>hraci[max].pocetViteztvi){
				max=i;
				remiza=false;
			}else{
				if(hraci[i].pocetViteztvi==hraci[max].pocetViteztvi) {
					remiza=true;
				}
			}
		}
		if(remiza){
			return "<html><font color=ccc >remiza </font>"+zbytekHracu()+" </html>";
		}
		return "<html><font Color="+toHex(hraci[max].barva)+">"+hraci[max].jmeno+"</font> je vitez  score: "+zbytekHracu()+"</html>";
    }
	private String zbytekHracu(){
		String vrat=new String();
		for (int i = 0; i < hraci.length; i++) {
				vrat=vrat+hraci[i].jmeno+" - "+hraci[i].pocetViteztvi+"   ";
		}
		return vrat;
	}

    private String toHex(Color barva){
	//ziskani barvy hrace v hex formatu pro hmtl
		String red=kontrolaDelky(Integer.toHexString(barva.getRed()));
		String green=kontrolaDelky(Integer.toHexString(barva.getGreen()));
		String blue=kontrolaDelky(Integer.toHexString(barva.getBlue()));
		return red+green+blue;
    }
    private String kontrolaDelky(String kontrol){
		if(kontrol.length()<2){
			kontrol="0"+kontrol;
		}
		return kontrol;
    }
    public void ukoncit(){
		 this.dispose();
    }
    
}