package tunneler;
import java.awt.*;
import java.util.ArrayList;
import java.util.Iterator;
import java.awt.Font;
import javax.swing.JPanel;
/**
 * @author vondrm4
 *
 *
 * uchovava informace o hraci - jmeno, pozici, smer, energii stity, strely
 * a pohledHrace
 */
public class Hrac extends JPanel{
    //x,y pravy horni roh okna,    
    //poloha tanku se pak dopocitava 
    //smer[0] zmena x, [1] zmena y, [2] natoceni tanku 
    //start - pozice zakladny
	//aktivni - prepinac - po zniceni tanku a nezkonceni kola false
    int x;
    int y;
    int[] smer;
    int[] start=new int[2];
    int[][] klavesnice;
	boolean aktivni=true;

    Mapa mapa;
    
    /*trigerrHappy- zmacknuti ctrl/enter
     *prepinac- pro mezeru mezi vystrely
     */
    ArrayList strely;
    int pocetStrel;    
    boolean triggerHappy=false;
    boolean prepinac=true;
    
    //[0] aktualni stav, [1] maximalni pocet
    int[] energy=new int[2];
    int[] shield=new int[2];
    
    int pocetViteztvi;
    //sirka vyska je pocet bodu ne pixelu
    int sirka;
    int vyska;
    int rozliseni;
    Color barva;
    PohledHrace pohled;
    Label info;
    
    String jmeno;
    Hra hra;

    public Hrac(String jmeno,Color barva,int[][] klavesnice,Hra hra) {
		//prvni dve cisla drzi informaci o pohybu treti udrzuje inf o smeru
		smer=new int[3];
		this.hra=hra;
		this.barva=barva;
		this.mapa=hra.mapa;
		this.jmeno=jmeno;
		this.klavesnice=klavesnice;
	
		energy[0]=2200;
		energy[1]=2200;
		shield[0]=900;
		shield[1]=900;
	
		sirka=hra.sirka;
		vyska=hra.vyska;
		rozliseni=hra.rozliseni;
		pohled=new PohledHrace(mapa, sirka, vyska, rozliseni, energy, shield);
		x=0;
		y=0;
		pocetStrel=10;
		strely=new ArrayList();
	
		info=new Label(pocetViteztvi+" "+jmeno);
		info.setFont(new Font("Serif",1,15));
		info.setForeground(barva);
		info.setBackground(mapa.menu);
	
		setBackground(mapa.menu);
		setLayout(new BorderLayout());
		this.add(info, BorderLayout.NORTH);
		this.add(pohled, BorderLayout.CENTER);
	
    }
    public void prekreslit(){
		//cast pro vypnuti vykreslovani
		if(!aktivni){
			return;
		}

		energy[0]--;
		if(energy[0]<0 || shield[0]<0){
			konecKola();
		}else{
			//poloha tanku
			int zacX=x+sirka/2-2;
			int zacY=y+vyska/2-2;
			insideBase(zacX,zacY);
	
	
			//kontrola jestli se tank nataci, zustava jako v minule poloze nebo pohybuje
			if(smer[2]!=urcitNatoceni()){
				smer[2]=urcitNatoceni();
				zahladitStopu();
				vykreslitTank();
			}else{
				if(smer[0]!=0 || smer[1]!=0){
					zahladitStopu();
					//spocitani pohybu a tunelovani
					kolize(zacX, zacY);
				}
				vykreslitTank();
			}
    
			pohled.prekreslit(x,y);
		}
    }
    public void prekreslitLoad(){   
		pohled.prekreslit();
	}
    
    private void insideBase(int zacX, int zacY){
	//dobijeni ve vlastni zakladne
		if(zacX>start[0]&& zacX<start[0]+mapa.zakSirka-5 && zacY>start[1] && zacY<start[1]+mapa.zakVyska-4){
			if(energy[0]+14<energy[1]) energy[0]+=14;
			else	energy[0]=energy[1];
	  
			if(shield[0]<shield[1]) shield[0]+=1;
			return;
		}
		//nepratelska zakladna
		for (int i = 0; i <hra.hraci.length; i++) {
			
			if(zacX>hra.hraci[i].start[0]&& zacX<hra.hraci[i].start[0]+mapa.zakSirka-5 && zacY>hra.hraci[i].start[1] && zacY<hra.hraci[i].start[1]+mapa.zakVyska-4){
				if(energy[0]+12<energy[1])	energy[0]+=12;
				else	energy[0]=energy[1];
				return;
			}
		}	
	}
    
    
    public void strelba(){
	//zajisteni vystrelu a prekreslovani strel
		//vypnuti sepnuti spouste po vybuch tanku
		if(!aktivni) triggerHappy=false;

		if(triggerHappy && strely.size()<pocetStrel){
		
			if(prepinac){
				strely.add(new Strela(x+sirka/2,y+vyska/2,smer[2], mapa));
				energy[0]-=9;
				prepinac=false;
			}else{
				prepinac=true;
			}
		}
		Strela docasna;
		for(int l=0; l<strely.size();l++){
			docasna=(Strela)strely.get(l);
			docasna.kreslit();
		}
		for(Iterator it = strely.iterator(); it.hasNext(); ){
			docasna=(Strela) it.next();
			if(docasna.smazat) it.remove();
		}
}
   
    private int urcitNatoceni(){
	//prevedeni pole smer na int
		int vrat;
		if(smer[0]==0&&smer[1]==0)vrat=smer[2];
		else if(smer[0]==-1&&smer[1]==0)vrat=0;
		else if(smer[0]==1&&smer[1]==0)vrat=1;
		else if(smer[0]==0&&smer[1]==1)vrat=3;
		else if(smer[0]==1&&smer[1]==-1)vrat=4;
		else if(smer[0]==-1&&smer[1]==1)vrat=5;
		else if(smer[0]==-1&&smer[1]==-1)vrat=6;
		else if(smer[0]==1&&smer[1]==1)vrat=7;
		else vrat=2;
		return vrat;
    }
    
    //KRESLENI TANKU
    private void vykreslitTank(){
		//pozice tanku od horniho leveho rohu
		int zacX=x+sirka/2-2;
		int zacY=y+vyska/2-2;
	    switch(smer[2]){
			case 0: tankLeft(zacX, zacY); break;
			case 1: tankRight(zacX, zacY); break;
			case 2: tankUp(zacX, zacY); break;
			case 3: tankDown(zacX, zacY);break;
			case 4: tankDiagonalUpRight(zacX, zacY);break;
			case 5: tankDiagonalDownLeft(zacX, zacY);break;
			case 6: tankDiagonalUpLeft(zacX, zacY);break;
			case 7: tankDiagonalDownRight(zacX, zacY);break;
			default: ; break;
	    }
    }
    private void tankUp(int zacX, int zacY){
	for(int i=0; i<5;i++){
		    for (int l=0;l<5;l++) {
		       if(((i==1||i==3)&&l==0)||((i==1||i==2||i==3)&&(l==4))){
		       }else if(i==2&&l==0){
				mapa.redrawTankKanon(this, zacX+i,zacY+l);
		        }else{
		        mapa.redrawTankBod(this, zacX+i, zacY+l);
				}
		    }
		}
    }
    private void tankDown(int zacX, int zacY){
	for(int i=0; i<5;i++){
		    for (int l=0;l<5;l++) {
		       if(((i==1||i==3)&&l==4)||((i==1||i==2||i==3)&&(l==0))){
		       }else if(i==2&&l==4){
				mapa.redrawTankKanon(this, zacX+i, zacY+l);
		        }else{
		        mapa.redrawTankBod(this, zacX+i, zacY+l);}
		    }
		}
    }
    private void tankLeft(int zacX, int zacY){
	for(int i=0; i<5;i++){
		    for (int l=0;l<5;l++) {
		       if(((l==1||l==3)&&i==0)||((l==1||l==2||l==3)&&(i==4))){
		       }else if(l==2&&i==0){
				mapa.redrawTankKanon(this, zacX+i, zacY+l);
		        }else{
		        mapa.redrawTankBod(this, zacX+i, zacY+l);}
		    }
		}
    }
    private void tankRight(int zacX, int zacY){
	for(int i=0; i<5;i++){
		    for (int l=0;l<5;l++) {
		       if(((l==1||l==3)&&i==4)||((l==1||l==2||l==3)&&(i==0))){
		    	//mapa.mapa[zacX+i][zacY+l]=Color.BLACK;
		       }else if(l==2&&i==4){
				mapa.redrawTankKanon(this, zacX+i, zacY+l);
		        }else{
		        mapa.redrawTankBod(this, zacX+i, zacY+l);}
		    }
		}
    }
    private void tankDiagonalUpLeft(int zacX, int zacY){
	for(int i=0; i<5;i++){
		    for (int l=0;l<5;l++) {
		       if(l==0&&i==0){
				mapa.redrawTankKanon(this, zacX+i, zacY+l);
		        }else if ((((l==1||l==2||l==3)&&i==1)||(i==2)||((l==1||l==2)&&i==3)||(l==2&&i==0)||(l==2&&i==4))){
		        mapa.redrawTankBod(this, zacX+i, zacY+l);}
		    }
		}
    }
    private void tankDiagonalDownLeft(int zacX, int zacY){
	for(int i=0; i<5;i++){
		    for (int l=0;l<5;l++) {
		       if(l==4&&i==0){
				mapa.redrawTankKanon(this, zacX+i,zacY+l);
		        }else if ((((l==1||l==2||l==3)&&i==1)||(i==2)||((l==3||l==2)&&i==3)||(l==2&&i==0)||(l==2&&i==4))){
		        mapa.redrawTankBod(this, zacX+i, zacY+l);}
		    }
		}
    }
    private void tankDiagonalDownRight(int zacX, int zacY){
	for(int i=0; i<5;i++){
		    for (int l=0;l<5;l++) {
		       if(l==4&&i==4){
				mapa.redrawTankKanon(this, zacX+i, zacY+l);
		        }else if ((((l==1||l==2||l==3)&&i==3)||(i==2)||((l==3||l==2)&&i==1)||(l==2&&i==0)||(l==2&&i==4))){
		        mapa.redrawTankBod(this, zacX+i, zacY+l);}
		    }
		}
    }
    private void tankDiagonalUpRight(int zacX, int zacY){
	for(int i=0; i<5;i++){
		    for (int l=0;l<5;l++) {
		       if(l==0&&i==4){
				mapa.redrawTankKanon(this, zacX+i, zacY+l);
		        }else if ((((l==1||l==2||l==3)&&i==3)||(i==2)||((l==3||l==2)&&i==1)||(l==2&&i==0)||(l==2&&i==4))){
		        mapa.redrawTankBod(this, zacX+i, zacY+l);}
		    }
		}
    }
    
    //KOLIZE
    private void kolize(int zacX, int zacY){
	//ziska typ materialu v danem smeru a pak bud tuneluje zastavi tank
		int[] okoli;
		switch(smer[2]){
			case 0: okoli=kolLeft(zacX, zacY); break;
			case 1: okoli=kolRight(zacX, zacY); break;
			case 2: okoli=kolUp(zacX, zacY); break;
			case 3: okoli=kolDown(zacX, zacY); break;
			case 4: okoli=kolDiagonalUpRight(zacX, zacY);break;
			case 5: okoli=kolDiagonalDownLeft(zacX, zacY);break;
			case 6: okoli=kolDiagonalUpLeft(zacX, zacY);break;
			case 7: okoli=kolDiagonalDownRight(zacX, zacY);break;
			default: okoli=new int[0]; break;
	    }
		//volny pohyb
		if(volnyPruchod(okoli)){
			this.x+=smer[0];
			this.y+=smer[1];
			return;
		}
		else if(tunelovani(okoli)){
			//pouze vytunelovani
			tunelovat(zacX,zacY);
			//pri strelbe pohyb zeminou rychle
			if(triggerHappy && strely.size()<pocetStrel){
				this.x+=smer[0];
				this.y+=smer[1];
			}
		}	
    }

    private boolean tunelovani(int[] okoli){
	//okoli musi byt pruchodne nebo obsahovat hlinu
		for (int i = 0; i < okoli.length; i++) {
			if(okoli[i]!=mapa.HLINA && okoli[i]!=mapa.VOLNE && okoli[i]!=mapa.STRELA)
				return false;
		}
		return true;
	}
	private boolean volnyPruchod(int[] okoli){
	//cele okoli musi byt pruchodne
		for (int i = 0; i < okoli.length; i++) {
			if(okoli[i]!=mapa.VOLNE && okoli[i]!=mapa.STRELA)
				return false;
		}
		return true;
	}


    //metody vracejici typ materialu v danem smeru
    private int[] kolUp(int zacX,int zacY){
		int[] poleTyp=new int[5];
		for(int i=0; i<poleTyp.length;i++){
			poleTyp[i]=mapa.mapa[zacX+i][zacY-1].typ;
		}
		return poleTyp;
    }    
    private int[] kolDown(int zacX,int zacY){
		int[] poleTyp=new int[5];
		for(int i=0; i<poleTyp.length;i++){
			poleTyp[i]=mapa.mapa[zacX+i][zacY+5].typ;
		}
		return poleTyp;
    }
    private int[] kolLeft(int zacX,int zacY){
		int[] poleTyp=new int[5];
		for(int i=0; i<poleTyp.length;i++){
			poleTyp[i]= mapa.mapa[zacX-1][zacY+i].typ;
		}
		return poleTyp;
    }
    private int[] kolRight(int zacX,int zacY){
		int[] poleTyp=new int[5];
		for(int i=0; i<poleTyp.length;i++){
			poleTyp[i]= mapa.mapa[zacX+5][zacY+i].typ;
		}
		return poleTyp;
    }
    private int[] kolDiagonalDownLeft(int zacX,int zacY){
		int[] poleTyp=new int[9];
		for(int i=0; i<5;i++){
			poleTyp[i]= mapa.mapa[zacX-1][zacY+1+i].typ;
		}
		for(int i=0; i<4;i++){
			poleTyp[i+5]= mapa.mapa[zacX+i][zacY+5].typ;
		}
		return poleTyp;
    }
    private int[] kolDiagonalUpRight(int zacX,int zacY){
		int[] poleTyp=new int[9];
		for(int i=0; i<5;i++){
			poleTyp[i]= mapa.mapa[zacX+5][zacY-1+i].typ;
		}
		for(int i=0; i<4;i++){
			poleTyp[i+5]= mapa.mapa[zacX+i+1][zacY-1].typ;
		}
		return poleTyp;
    }
    private int[] kolDiagonalDownRight(int zacX,int zacY){
		int[] poleTyp=new int[9];
		for(int i=0; i<5;i++){
			poleTyp[i]= mapa.mapa[zacX+5][zacY+1+i].typ;
		}
		for(int i=0; i<4;i++){
			poleTyp[i+5]= mapa.mapa[zacX+1+i][zacY+5].typ;
		}
		return poleTyp;
    }
    private int[] kolDiagonalUpLeft(int zacX,int zacY){
		int[] poleTyp=new int[9];
		for(int i=0; i<5;i++){
			poleTyp[i]= mapa.mapa[zacX-1][zacY-1+i].typ;
		}
		for(int i=0; i<4;i++){
			poleTyp[i+5]= mapa.mapa[zacX+i-1][zacY-1].typ;
		}
		return poleTyp;
    }
    
    //TUNELOVANI
    private void tunelovat(int zacX,int zacY){
		switch(smer[2]){
		case 0: tunLeft(zacX, zacY); break;
		case 1: tunRight(zacX, zacY); break;
		case 2: tunUp(zacX, zacY); break;
		case 3: tunDown(zacX, zacY); break;
		case 4: tunUp(zacX+1,zacY); tunRight(zacX,zacY-1);break;
		case 5: tunDown(zacX-1, zacY);tunLeft(zacX,zacY+1);break;
		case 6: tunUp(zacX-1, zacY); tunLeft(zacX,zacY-1);break;
		case 7: tunDown(zacX+1, zacY);tunRight(zacX,zacY+1);break;
		default:; break;
	    }
    }
    private void tunLeft(int zacX,int  zacY){
		for(int i=0; i<5;i++){
			mapa.redrawEmpty(zacX-1, zacY+i);
		} 
    }
    private void tunRight(int zacX,int  zacY){
		for(int i=0; i<5;i++){
			mapa.redrawEmpty(zacX+5, zacY+i);
		} 
    }
    private void tunUp(int zacX,int  zacY){
		for(int i=0; i<5;i++){
			mapa.redrawEmpty(zacX+i, zacY-1);
		} 
    }
    private void tunDown(int zacX,int  zacY){
		for(int i=0; i<5;i++){
			mapa.redrawEmpty(zacX+i, zacY+5);
		}
    }   
    
    private void zahladitStopu(){
	//spoustet pred upravou XY a pred nactenim pokynu z klavesnice
		int zacX=x+sirka/2-2;
		int zacY=y+vyska/2-2;
		if(zacX>0 && zacY>0 && zacX<mapa.sirka+sirka/2+3 && zacY<mapa.vyska+vyska/2+3){
			for(int i=0; i<5;i++){
				for (int l=0;l<5;l++) {
					mapa.redrawEmpty(zacX+i, zacY+l);
				}
			}
		}
    }
    //starty/konce KOL
    private void konecKola(){
	//volano pri shield nebo energy <0
		boom(x+sirka/2,y+vyska/2);
		zahladitStopu();
		aktivni=false;
		//snizeni poctu zustavajicich hracu
		hra.aktivni--;
		pohled.prekreslit();
    }
    public void noveKolo(){
	//pri zacatku noveho kola z hra
		zahladitStopu();
		Iterator i=strely.iterator();
		Strela docasna;
		while(i.hasNext()){
			docasna=(Strela) i.next();
			docasna.smazani();
		}
		strely.clear();
		info.setText(pocetViteztvi+" "+jmeno);
		aktivni=true;
		setToBase();
    }
    
     private void boom(int polx,int poly){
     //vybuch tanku
		int nahoda=((int) Math.round(Math.random()*10))+7;
		int nahX;
		int nahY;
		for (int i=0; i< nahoda; i++) {
			nahX=(int) Math.round(Math.random()*8+2);
			nahY=(int) Math.round(Math.random()*8+2);
			if((polx+nahX>0 && polx+nahX<mapa.mapa.length) && (poly+nahY>0 && poly+nahY<mapa.mapa[0].length)){
				if( mapa.mapa[polx+nahX][poly+nahY].typ==mapa.HLINA){
					mapa.redrawEmpty(polx+nahX,poly+nahY);
				}
			}
		}
    }
    //ZAKLADNA
    public void setBase(int zacX, int zacY){
		start[0]=zacX;
		start[1]=zacY;
		setToBase();
    }
    private void setToBase(){
		energy[0]=energy[1];
		shield[0]=shield[1];
		smer[2]=0;
		x=start[0]-sirka/2+mapa.zakSirka/2;
		y=start[1]-vyska/2+mapa.zakVyska/2;
    }
}
