package tunneler;
import java.awt.*;
/**
 * @author vondrm4
 */
// vyska a sirka se udava v RELATIVNICH bodech, az po vynasobeni rozlisenim se dostanou pixely
public class PohledHrace extends Canvas{
    Color[][] obrazovka;
    Mapa mapa;
    int sirka;
    int vyska;
    int rozliseni;
    int[] ovladani;
    int[] energy;
    int[] shield;
    //buffer promene
    private Image dbImage;
    private Graphics dbg;

    public PohledHrace(Mapa mapa,int velX, int velY, int rozliseni, int[] energy, int[] shield) {
		this.mapa=mapa;
		this.sirka=velX;
		this.vyska=velY;
		this.rozliseni=rozliseni;
		this.obrazovka=mapa.getPodPole(0, 0, sirka, vyska);
		this.energy=energy;
		this.shield=shield;
    }
    public void prekreslit(int x,int y){
	//vykresleni pri normalnim stavu
		if(energy[0]<10*energy[1]/100 && (int) Math.round(Math.random()*3)>1){
			//ruseni pri nizke energii
			obrazovka=mapa.getStatic(sirka,vyska);
		}else{
			obrazovka=mapa.getPodPole(x, y, sirka, vyska);
		}
		this.repaint();
    }
    public void prekreslit(){
	//prekresleni pri loadingu/vybuchu tanku
        obrazovka=mapa.getLoad(sirka, vyska);
        this.repaint();
    }
	@Override
    public void paint(Graphics g){
		Graphics2D g2=(Graphics2D)g;
		g2.setColor(mapa.menu);
		g2.fillRect(0, 0, rozliseni*sirka, rozliseni*vyska+7*rozliseni);
		//normalni zobrazeni plochy, obrazovka je updatovana v prekreslit()
		for(int i=0; i<obrazovka.length;i++){
			for(int l=0; l<obrazovka[i].length;l++){
				g2.setColor(obrazovka[i][l]);
				g2.fillRect(i*rozliseni, l*rozliseni,  rozliseni, rozliseni);
			}
		}
		//zobrazeni energii a stitu
		g2.setColor(mapa.energy);
		g2.fillRect(rozliseni, vyska*rozliseni+1*rozliseni, (sirka*rozliseni-2*rozliseni)*energy[0]/energy[1], 2*rozliseni);
		g2.setColor(mapa.shield);
		g2.fillRect(rozliseni, vyska*rozliseni+4*rozliseni, (sirka*rozliseni-2*rozliseni)*shield[0]/shield[1], 2*rozliseni);
    }
	@Override
    public void update (Graphics g){
	//pouziti dvojiteho vykresleni aby obraz neblikal
      if (dbImage == null){
           dbImage = createImage (this.getSize().width, this.getSize().height);
           dbg = dbImage.getGraphics ();
      }
      dbg.setColor (getBackground ());
      dbg.fillRect (0, 0, this.getSize().width, this.getSize().height);

      dbg.setColor (getForeground());
      paint (dbg);
      //vykresli ve predu
      g.drawImage (dbImage, 0, 0, this);

} 
	@Override
    public Dimension getPreferredSize(){
		return new Dimension (sirka*rozliseni,vyska*rozliseni+7*rozliseni);
    }
}
