package tunneler;
import java.awt.*;
/**
 * @author vondrm4
 *
 *
 * vraci vykresleny pohled na celou mapu pri ukonceni hry
 */
public class PohledMapa extends Canvas{
    Color[][] obrazovka;
    Mapa mapa;
    int sirka;
    int vyska;
    int rozliseni;
    //buffer promene
    private Image dbImage;
    private Graphics dbg;

    public PohledMapa(Mapa mapa, int rozliseni) {
		this.mapa=mapa;
		this.sirka=mapa.mapa.length;
		this.vyska=mapa.mapa[0].length;
		this.rozliseni=rozliseni;

    }
	@Override
    public void paint(Graphics g){
		Graphics2D g2=(Graphics2D)g;
		g2.setColor(mapa.menu);
		g2.fillRect(0, 0, rozliseni*sirka, rozliseni*vyska);
		//normalni zobrazeni plochy
		for(int i=0; i<sirka;i++){
			for(int l=0; l<vyska;l++){
				g2.setColor(mapa.mapa[i][l].barva);
				g2.fillRect(i*rozliseni, l*rozliseni,  rozliseni, rozliseni);
			}
		}
    }
	@Override
    public void update (Graphics g){
	
		if (dbImage == null){
			dbImage = createImage (this.getSize().width, this.getSize().height);
			dbg = dbImage.getGraphics ();
		}
		dbg.setColor (getBackground ());
		dbg.fillRect (0, 0, this.getSize().width, this.getSize().height);

		dbg.setColor (getForeground());
		paint (dbg);
		//vykresli ve predu
		g.drawImage (dbImage, 0, 0, this);

	}
	@Override
    public Dimension getPreferredSize(){
		return new Dimension (sirka*rozliseni,vyska*rozliseni+7*rozliseni);
    }
}
