package tunneler;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 *
 * @author vondrm4
 *
 *
 * okno pro nastaveni ovladani pro jednolive hrace
 */
public class Settings extends JFrame implements KeyListener{

	Zavadec parent;
	JButton restDef;
	JButton okDone;
	ActionListener klik;
	
	ButtonNast[][] tlacitkoKlav;
	JLabel[][] popisKlav;
	JLabel[] jmenoHrace;
	JPanel[] hracRadka;
	JPanel[] hrac;
	String[] buttonLabel;
	JPanel seskupitHrace;
	
	
	Vlastnosti vlastnosti;

	//spinac kdy ma keypressed nastavovat
	boolean listenOn=false;
	//u ktereho hrace a ktera klavesa se nastavi
	int indexHrac;
	int indexKlavesa;
	
	private class ButtonNast extends JButton{
	//JButton s promenymi pro urceni hrace a klavesy ktera se ma nastavit
		int indexHrac;
		int indexKlavesa;
		private ButtonNast(String label, int hrac, int klavesa, ActionListener l){
			super(label);
			indexHrac=hrac;
			indexKlavesa=klavesa;
			addActionListener(l);
		}	
	}

	public Settings(Zavadec zavadec){
		super ("Nastaveni olvadani");
		parent=zavadec;

		klik= new ActionListener() {
		//akce ktera nastavi prepinac a ktery hrac a klavesa se ma nastavit
			@Override
			public void actionPerformed(ActionEvent e) {
				ButtonNast puvodce=(ButtonNast) e.getSource();
				System.out.println(puvodce.indexHrac);
				indexHrac=puvodce.indexHrac;
				indexKlavesa=puvodce.indexKlavesa;
				listenOn=true;
			}
		};

		vlastnosti=parent.vlastnosti;

		tlacitkoKlav=new ButtonNast[vlastnosti.ovladani.length][5];
		popisKlav=new JLabel[vlastnosti.ovladani.length][5];
		hracRadka=new JPanel[vlastnosti.ovladani.length];
		jmenoHrace=new JLabel[vlastnosti.ovladani.length];
		hrac=new JPanel[vlastnosti.ovladani.length];

		buttonLabel=new String[5];
		buttonLabel[0]=new String("strelba");
		buttonLabel[1]=new String("levo");
		buttonLabel[2]=new String("pravo");
		buttonLabel[3]=new String("nahoru");
		buttonLabel[4]=new String("dolu");

		//vytvoreni buttonu, a popisku
		for (int i = 0; i < tlacitkoKlav.length; i++) {
			hrac[i]=new JPanel();
			hrac[i].setLayout(new BorderLayout());

			jmenoHrace[i]=new JLabel();
			hrac[i].add(jmenoHrace[i], BorderLayout.NORTH);
			hracRadka[i]=new JPanel();
			hracRadka[i].setLayout(new GridLayout(5,2));

			for (int j = 0; j < tlacitkoKlav[i].length; j++) {
				tlacitkoKlav[i][j]=new ButtonNast(buttonLabel[j],i, j, klik);
				tlacitkoKlav[i][j].addKeyListener(this);

				popisKlav[i][j]=new JLabel();				
				hracRadka[i].add(tlacitkoKlav[i][j]);
				hracRadka[i].add(popisKlav[i][j]);
				
			}
			hrac[i].add(hracRadka[i], BorderLayout.CENTER);
			
		}
		
		seskupitHrace=new JPanel();
		seskupitHrace.setLayout(new GridLayout(2,2));
		for (int i = 0; i < hrac.length; i++) {
			seskupitHrace.add(hrac[i]);
			
		}
		
		okDone=new JButton("ok");
		okDone.addActionListener( new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				setUpDone();
			}
		} );

		restDef=new JButton("default ovladani");
		restDef.addActionListener( new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				parent.vlastnosti=new Vlastnosti();
				vlastnosti=parent.vlastnosti;
				setLabels();
			}
		} );
		
		setLayout(new FlowLayout());

		add(seskupitHrace);
		add(restDef);
		add(okDone);

		setSize(450, 400);
		setLocationRelativeTo(parent);
		addKeyListener(this);
		//window listener pro spravnou akci pri zavreni okna
		addWindowListener(new WindowListener(){

			@Override
			public void windowOpened(WindowEvent e) {
			}

			@Override
			public void windowClosing(WindowEvent e) {
				setUpDone();
			}

			@Override
			public void windowClosed(WindowEvent e) {
			}

			@Override
			public void windowIconified(WindowEvent e) {
			}

			@Override
			public void windowDeiconified(WindowEvent e) {
			}

			@Override
			public void windowActivated(WindowEvent e) {
			}

			@Override
			public void windowDeactivated(WindowEvent e) {
			}

		});

	}
	public void setUp(){
	//aktivace okna
		parent.setVisible(false);
		setLabels();
		setVisible(true);

	}
	private void setUpDone(){
	//zavreni okna
		this.setVisible(false);
		parent.setVisible(true);
	}
	private void setLabels(){
	//nastavi aktualni popisky ovladani
		for (int i = 0; i < tlacitkoKlav.length; i++) {
			jmenoHrace[i].setText(parent.hracJmeno[i].getText());
			for (int j = 0; j < tlacitkoKlav[i].length; j++) {
				popisKlav[i][j].setText(" "+KeyEvent.getKeyText(vlastnosti.ovladani[i][j][0])+" ("+vlastnosti.ovladani[i][j][0]+", "+vlastnosti.ovladani[i][j][1]+")");
			}
		}
	}
	//KEY EVENTS
	@Override
	public void keyTyped(KeyEvent e) {
	}

	@Override
	public void keyPressed(KeyEvent e) {
		if(listenOn){
			vlastnosti.ovladani[indexHrac][indexKlavesa][0]=e.getKeyCode();
			vlastnosti.ovladani[indexHrac][indexKlavesa][1]=e.getKeyLocation();
			popisKlav[indexHrac][indexKlavesa].setText(" "+KeyEvent.getKeyText(vlastnosti.ovladani[indexHrac][indexKlavesa][0])+" ("+vlastnosti.ovladani[indexHrac][indexKlavesa][0]+", "+vlastnosti.ovladani[indexHrac][indexKlavesa][1]+")");
			listenOn=false;
		}else{

		}

	}

	@Override
	public void keyReleased(KeyEvent e) {
	}

}
