package tunneler;
/**
 * @author vondrm4
 *
 *
 * uchovava informace o strele, stara se o vykresleni, spocitani pohybu, kolize jedne strely
 */
public class Strela {
    int x;
    int y;
    //v rychlost strely;
    int v;
    int smer;
	//indikator pro smazani
	boolean smazat=false;
    //kam se ma vykreslit druhy bod strely
    int[] druhyBod=new int[2];
    Hrac nepritel;
    Mapa mapa;
    boolean stop;
    
	public Strela(int x, int y, int smer, Mapa mapa) {
	//ziskane x a y odpovida stredu tanku podle smeru se urci posunuta pozice, misto pro druhy bod strely
		switch(smer){
			case 0: druhyBod[0]=1; druhyBod[1]=0; this.x=x-2; this.y=y; break;
			case 1: druhyBod[0]=-1; druhyBod[1]=0; this.x=x+2; this.y=y; break;
			case 2: druhyBod[0]=0; druhyBod[1]=1; this.x=x; this.y=y-2; break;
			case 3: druhyBod[0]=0; druhyBod[1]=-1; this.x=x; this.y=y+2; break;
			case 4: druhyBod[0]=-1; druhyBod[1]=1; this.x=x+2; this.y=y-2; break;
			case 5: druhyBod[0]=1; druhyBod[1]=-1; this.x=x-2; this.y=y+2; break;
			case 6: druhyBod[0]=1; druhyBod[1]=1; this.x=x-2; this.y=y-2; break;
			case 7: druhyBod[0]=-1; druhyBod[1]=-1; this.x=x+2; this.y=y+2; break;
			default: druhyBod[0]=0; druhyBod[1]=0; this.x=x-2; this.y=y; break;
	    }
		this.smer=smer;
		this.mapa=mapa;
		this.v=2;
    }
    public void kreslit(){
		//prvni cast zakreje predchozi strelu
		mapa.redrawStrelaEmpty(x, y, druhyBod[0], druhyBod[1]);
		//je strela jeste v prostoru mapy
		if((x-v>0 && x+v<mapa.mapa.length) && (y-v>0 && y+v<mapa.mapa[0].length)){
			canMove();
		}else{
			smazat=true;
		}
    }
	private void canMove(){
		int temp;
		//proverujeme vsechny body kterymi ma strela proletet
		//prictenim opacne hodnoty nez je pro druhou cast streli dostaneme bod kam doleti
		for (int i = 1; i < v+1; i++) {
			temp=mapa.mapa[x-(druhyBod[0]*i)][y-(druhyBod[1]*i)].typ;
			if(temp==mapa.VOLNE || temp==mapa.STRELA ){
				continue;
			}
			if(temp==mapa.TANK){
				//tanl zasah
				mapa.mapa[x-(druhyBod[0]*i)][y-(druhyBod[1]*i)].parent.shield[0] -=80;
				//boom(x-2*polX,y-2*polY);
				smazat=true;
				return;
			}
			if(temp==mapa.NEPROSTUPNE){
				//naraz
				smazat=true;
				return;
			}
			if(temp==mapa.HLINA){
				//TUNELOVAT
				boom(x-(druhyBod[0]*i), y-(druhyBod[1]*i));
				smazat=true;
				return;
			}
		}
		x+=-druhyBod[0]*v;
		y+=-druhyBod[1]*v;
		mapa.redrawStrela(x, y, druhyBod[0], druhyBod[1]);
		return;
	}
	private void boom(int polx,int poly){
    //naraz strely do hliny
		int nahoda=((int) Math.round(Math.random()*3))+2;
		int nahX;
		int nahY;
		int[] korekce=new int[2];
		// 'rozprsknuti' strely do okoli
		switch(smer){
			case 0: korekce[0]=5;korekce[1]=2; break;
			case 1: korekce[0]=5;korekce[1]=2; break;
			case 2: korekce[0]=2;korekce[1]=5; break;
			case 3: korekce[0]=2;korekce[1]=5;; break;
			case 4: korekce[0]=3;korekce[1]=3;; break;
			case 5: korekce[0]=3;korekce[1]=3; break;
			case 6: korekce[0]=3;korekce[1]=3; break;
			case 7: korekce[0]=3;korekce[1]=3; break;
			default:korekce[0]=3;korekce[1]=3; break;
	    }
		for (int i=0; i< nahoda; i++) {
			nahX=(int) Math.round(Math.random()*korekce[0]-korekce[0]/2);
			nahY=(int) Math.round(Math.random()*korekce[0]-korekce[0]/2);
			if((polx+nahX>0 && polx+nahX<mapa.mapa.length) && (poly+nahY>0 && poly+nahY<mapa.mapa[0].length)){
				if(mapa.mapa[polx+nahX][poly+nahY].typ==mapa.HLINA){
					mapa.redrawEmpty(polx+nahX, poly+nahY);
				}
			}
		}
		if(mapa.mapa[polx][poly].typ==mapa.HLINA){
			mapa.redrawEmpty(polx, poly);
		}
    }
    
    public void smazani(){
		mapa.redrawStrelaEmpty(x, y, druhyBod[0], druhyBod[1]);
    }
}