package tunneler;
import java.awt.*;
import java.awt.event.*;
import java.awt.Font;
import javax.swing.*;
import java.io.*;

/**
 * @author vondrm4
 *
 * 
 * umoznuje nastaveni poctu hracu, jmen a ovladani - pak preda konstruktou hra
 */
public class Zavadec extends JFrame{
    JLabel popis;
	JLabel warning;
	
	
	//check boxy, text fieldy pro nastaveni hracu + 1 jpanel  pocet kol
	Vlastnosti vlastnosti;
	String soubor="config.dat";
	JPanel[] hracInfo=new JPanel[4];
	JTextField[] hracJmeno=new JTextField[4];
	JCheckBox[] hracOn=new JCheckBox[4];

	JLabel pocet;
    JTextField pocetKol;
	JPanel kolaInfo=new JPanel();
	
	Settings nastaveni;
	
	JButton setting;
    JButton start;
    JButton end;

    public Zavadec() {
		super("jTunneler");
		popis=new JLabel("jTunneler");
		popis.setFont(new Font("SanSerif",1,40));
		
		vlastnosti=setVlastnosti();

		for (int i = 0; i < hracJmeno.length; i++) {
			hracJmeno[i]=new JTextField(vlastnosti.jmena[i]);
			hracOn[i]=new JCheckBox();
			hracOn[i].setSelected(vlastnosti.on[i]);

			hracInfo[i]=new JPanel();
			hracInfo[i].setLayout(new FlowLayout());

			hracInfo[i].add(hracOn[i]);
			hracInfo[i].add(hracJmeno[i]);
		}
		
		warning=new JLabel();
		warning.setForeground(Color.RED);
	

		pocet=new JLabel(" pocet kol");
		pocetKol=new JTextField("3");
	
		JPanel panel1=new JPanel();
		panel1.setLayout(new GridLayout(6,1));

		for (int i = 0; i < hracInfo.length; i++) {
			panel1.add(hracInfo[i]);
		}
		kolaInfo.add(pocetKol);
		kolaInfo.add(pocet);

		panel1.add(kolaInfo);
		panel1.add(warning);
	
	

		nastaveni=new Settings(this);
		setting=new JButton("nastaveni ovladani");
		setting.addActionListener( new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {  nastaveni.setUp(); }
		} );
	
		Panel tlacitka=new Panel();
		tlacitka.setLayout(new GridLayout(1,2));
		start=new JButton("start");
		start.addActionListener( new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {  startGame(); }
		} );
	
		end=new JButton("konec");
		end.addActionListener( new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {  System.exit(0); }
		} );
  
		tlacitka.add(start);
		tlacitka.add(end);
	
		setLayout(new FlowLayout());
		add(popis);
		add(panel1);
		add(setting);
		add(tlacitka);
		setSize(230,350);
		setLocation(50,50);
		setVisible(true);

		addWindowListener(new WinControls());
    }
    public void startGame(){
		if(startCheck()){
			saveVlastnosti();
			Hra newGame=new Hra(getNames(), getColors(), getOvladani(),Integer.parseInt(pocetKol.getText()), this);
		}
    
    }
	private Vlastnosti setVlastnosti(){
	//nastaveni ovladani, jmen, barev, poctu kol - pokud neexistuje ulozene nastaveni pouzije se defaultni
		File saved=new File(soubor);
		Vlastnosti vratit;
		try {
			ObjectInputStream in = new ObjectInputStream(new FileInputStream(saved));
			try {
				vratit = (Vlastnosti) in.readObject();
			}catch (ClassNotFoundException ex) {
				System.out.println(soubor+" vadny");
				vratit=new Vlastnosti();
			}
			in.close();
		}catch (FileNotFoundException ex) {
			System.out.println("default nastaveni");
			vratit= new Vlastnosti();
		}catch (IOException ex) {
			System.out.println("chyba pri cteni nastaveni");
			vratit= new Vlastnosti();
		}
		return vratit;
	}
	private void saveVlastnosti(){
	//ulozeni nastaveni, volat po provedeni startCheck()
		for (int i = 0; i < vlastnosti.jmena.length; i++) {
			vlastnosti.jmena[i]=hracJmeno[i].getText();
			vlastnosti.on[i]=hracOn[i].isSelected();
		}
		vlastnosti.pocetKol=Integer.parseInt(pocetKol.getText());

		ObjectOutputStream out = null;
		try {
			out = new ObjectOutputStream(new FileOutputStream(soubor));
			out.writeObject(vlastnosti);
			out.close();
			System.out.println("nastaveni ulozeno");
		} catch (IOException ex) {
			System.out.println("chyba pri ukladnai");
		} finally {
			try {
				out.close();
			} catch (IOException ex) {
			}
		}
	}
    private boolean startCheck(){
	//kontrola poctu hracu, kol, delky jmen
		for (int i = 0; i < hracJmeno.length; i++) {
			if(hracJmeno[i].getText().length()>30){
				hracJmeno[i].setText("maximalne 30 znaku");
				warning.setText("chyba !!");
				return false;
			}
		}
		if(getOnHraci()<2){
			warning.setText("Minimum 2 hraci !!");
			return false;
		}

		try{
			int i = Integer.parseInt(pocetKol.getText());
			if(i<1){
				pocetKol.setText("1");
			}
		}catch (NumberFormatException v){
			warning.setText("Zadejte cislem");
			return false;
		}
		warning.setText("");
		return true;
    
    }	
	private String[] getNames(){
	//vraci jmena povolenych hracu
		String[] jmena=new String[getOnHraci()];
		int l=0;
		for (int i = 0; i < hracJmeno.length; i++) {
			if(hracOn[i].isSelected()){
				jmena[l] = hracJmeno[i].getText();
				l++;
			}
		}
		return jmena;
	}
	private Color[] getColors(){
	//vraci barvy povolenych hracu
		Color[]colors=new Color[getOnHraci()];
		int l=0;
		for (int i = 0; i < hracOn.length; i++) {
			if(hracOn[i].isSelected()){
				colors[l] = vlastnosti.barvy[i];
				l++;
			}
		}
		return colors;
	}
	private int[][][] getOvladani(){
	//vraci ovladni povolenych hracu
		int[][][] controls=new int[getOnHraci()][][];
		int l=0;
		for (int i = 0; i < hracOn.length; i++) {
			if(hracOn[i].isSelected()){
				controls[l] = vlastnosti.ovladani[i];
				l++;
			}
		}

		return controls;
	}
	private int getOnHraci(){
	//vraci pocet povolench hracu [pro lehci getName, getColor...]
		int l=0;
		for (int i = 0; i < hracOn.length; i++) {
			if(hracOn[i].isSelected()) l++;
		}
		return l;
	}
    
}
